// Copyright 2006 all rights reserved; see LICENSE file for BSD-style license

package edu.berkeley.sbp.meta;

import edu.berkeley.sbp.util.*;
import edu.berkeley.sbp.*;
import edu.berkeley.sbp.chr.*;
import edu.berkeley.sbp.misc.*;
import edu.berkeley.sbp.bind.*;
import java.util.*;
import java.lang.annotation.*;
import java.lang.reflect.*;
import java.io.*;

public class ArrayBuildingTreeFunctor<T> implements TreeFunctor<T,T[]>, ToJava {

    public void toJava(StringBuffer sb) { sb.append("new ArrayBuildingTreeFunctor()"); }
    public String toString() { return ""; }
        
    public T[] invoke(Iterable<Tree<T>> t) {
        ArrayList ret = new ArrayList();
        for(Tree tc : t) {
            if (tc.head() != null && tc.head() instanceof Functor)
                ret.add(((Functor<Iterable<Tree>,Object>)tc.head()).invoke(tc.children()));
            else if (tc.size() == 0)
                ret.add(tc.head());
            else {
                System.err.println("FIXME: don't know what to do about " + tc);
                ret.add(null);
            }
        }
        return (T[])ret.toArray(new Object[0]);
    }
}
